Please use the Apache issue tracking system for new NetBeans issues (https://issues.apache.org/jira/projects/NETBEANS0/issues) !!
Bug 186984 - [69cat] IDE might freeze when opening DB nodes
[69cat] IDE might freeze when opening DB nodes
Status: VERIFIED FIXED
Product: db
Classification: Unclassified
Component: Code
6.x
PC Windows XP
: P2 (vote)
: 7.0
Assigned To: javydreamercsw
issues@db
69patch1
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2010-05-31 10:49 UTC by Erno Mononen
Modified: 2010-07-08 10:50 UTC (History)
4 users (show)

See Also:
Issue Type: DEFECT
:


Attachments
thread dump (20.09 KB, text/plain)
2010-06-02 08:57 UTC, Erno Mononen
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Erno Mononen 2010-05-31 10:49:10 UTC
Separated from #186677, for more info please ask javydreamercsw (in CC). A thread dump is attached.
Comment 1 javydreamercsw 2010-06-01 16:00:34 UTC
See issue #186677 for attachment.
Comment 2 Jiri Rechtacek 2010-06-02 08:48:07 UTC
Which one is related to DB area? Attach it here. Please, describe your steps. Thanks
Comment 3 Erno Mononen 2010-06-02 08:57:13 UTC
Created attachment 99748 [details]
thread dump

I thought I attached this when I first filed the bug, but apparently it didn't make it to the issue. Trying again...
Comment 4 Jiri Rechtacek 2010-06-02 09:12:15 UTC
Thanks. I see a problematic part is:
org.netbeans.modules.keyring.fallback.MasterPasswordEncryption.unlockIfNecessary(MasterPasswordEncryption.java:163)
	at org.netbeans.modules.keyring.fallback.MasterPasswordEncryption.unlockIfNecessary(MasterPasswordEncryption.java:149)
	at org.netbeans.modules.keyring.fallback.MasterPasswordEncryption.encrypt(MasterPasswordEncryption.java:115)
	at org.netbeans.modules.keyring.fallback.FallbackProvider._save(FallbackProvider.java:170)
	at org.netbeans.modules.keyring.fallback.FallbackProvider.testSampleKey(FallbackProvider.java:98)
	at org.netbeans.modules.keyring.fallback.FallbackProvider.enabled(FallbackProvider.java:84)
	at org.netbeans.api.keyring.Keyring.provider(Keyring.java:73)
	- locked <0x34268868> (a java.lang.Class for org.netbeans.api.keyring.Keyring)
	at org.netbeans.api.keyring.Keyring.read(Keyring.java:94)
	- locked <0x34268868> (a java.lang.Class for org.netbeans.api.keyring.Keyring)
	at org.netbeans.modules.db.explorer.DatabaseConnectionConvertor.createDatabaseConnection(DatabaseConnectionConvertor.java:239)

Some (rarely) OS platforms/configurations doesn't provide native KeyRing infrastucture thus IDE uses a fallback provider which needs user interaction. It means opening Database node could wait for user's input in such systems.
A possible fix can by replan creating affected sub-nodes later.
Comment 5 Jiri Rechtacek 2010-06-02 13:03:21 UTC
core-main/rev/cacfd605bdfe
Comment 6 Quality Engineering 2010-06-03 06:14:50 UTC
Integrated into 'main-golden', will be available in build *201006030001* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/cacfd605bdfe
User: Jiri Rechtacek <jrechtacek@netbeans.org>
Log: #186984: IDE could freeze when opening DB nodes
Comment 7 Antonin Nebuzelsky 2010-06-03 11:05:54 UTC
Let's plan the fix for 6.9.1.
Comment 8 Antonin Nebuzelsky 2010-06-03 13:42:40 UTC
For the record:

According to our evaluation this is not a freeze. NetBeans UI is blocked by a KeyRing dialog box which asks the user for the master password.

We assume this bug report means that you don't see the master password dialog box on your screen, possibly hidden by some other window, like NetBeans main window.

The fix in this issue only postpones the Keyring.read() call, so that the expanded nodes should first really expand, but the master password dialog will be shown to you anyway.

Thus marking as 6.9.1 candidate, not a stopper fix for 6.9.

javydreamercsw, please confirm that when you find the master password dialog, fill the info in and close it, you are able to continue working with NetBeans.
Comment 9 javydreamercsw 2010-06-03 13:51:36 UTC
When I tried it on today's build I did get the screen and disposing it continued the process. Is it normal to get the prompt so often? I usually have to open it 4-5 times during the day. Without the fix in RC's and/or 6.9 release any situation when the prompt doesn't appear on screen (I remember I looked to everything open using ctrl+tab looking for some kind of error screen) will give the user the idea that the IDE is frozen. Somehow this prevented the dialog to be displayed.

That kind of prompts should be modal so there's no way of hiding it, at least with the IDE itself it that was the case. Its your call guys, hopefully complaints don't start raining after release...
Comment 10 Jiri Rechtacek 2010-06-03 14:06:52 UTC
javydreamercsw, I see problematic you disposing that dialog. If you set a master password, IDE won't be remind you any more (only once for one IDE session). Moreover as I stated above, most of OS/platform provides own native storing passwords infrastructure, it means IDE users on such platforms won't be annoyed any more.
Comment 11 rbalada 2010-06-16 08:54:36 UTC
Please verify bugfix for this bug, so it can be included in release691 repository.

Thanks,
-R
Comment 12 Jiri Kovalsky 2010-06-16 09:12:45 UTC
Javier, can you please verify this? Thanks a lot!
Comment 13 javydreamercsw 2010-06-16 12:04:33 UTC
Verified in 201006130001.

In my case the key ring prompt is happening now basically at start up. I haven't seen the issue for a couple of builds now.
Comment 14 Jiri Kovalsky 2010-06-16 12:13:25 UTC
Thank you very much Javier.
Comment 15 rbalada 2010-06-16 13:14:45 UTC
Transplanted to release691 as d5e5021cd3f2
Comment 16 Jaroslav Pospisil 2010-07-08 10:50:42 UTC
v. in 201007062301


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo